diff -NurpP --minimal linux-2.6.8.1/arch/ppc64/kernel/sys_ppc32.c linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/sys_ppc32.c
--- linux-2.6.8.1/arch/ppc64/kernel/sys_ppc32.c	2004-08-14 12:55:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/sys_ppc32.c	2004-08-25 18:49:25.000000000 +0200
@@ -60,6 +60,7 @@
 #include <linux/ptrace.h>
 #include <linux/aio_abi.h>
 #include <linux/elf.h>
+#include <linux/vs_cvirt.h>
 
 #include <net/scm.h>
 #include <net/sock.h>
@@ -1154,6 +1155,7 @@ asmlinkage long sys32_time(compat_time_t
 asmlinkage int sys32_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 	
 	if (!name)
 		return -EFAULT;
@@ -1161,15 +1163,16 @@ asmlinkage int sys32_olduname(struct old
 		return -EFAULT;
   
 	down_read(&uts_sem);
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error -= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error -= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error -= __put_user(0,name->release+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error -= __put_user(0,name->version+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error = __put_user(0,name->machine+__OLD_UTS_LEN);
 	up_read(&uts_sem);
 
diff -NurpP --minimal linux-2.6.8.1/arch/ppc64/mm/hugetlbpage.c linux-2.6.8.1-vs1.9.2/arch/ppc64/mm/hugetlbpage.c
--- linux-2.6.8.1/arch/ppc64/mm/hugetlbpage.c	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc64/mm/hugetlbpage.c	2004-08-25 18:49:34.000000000 +0200
@@ -125,7 +125,8 @@ static void setup_huge_pte(struct mm_str
 	hugepte_t entry;
 	int i;
 
-	mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	// mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	vx_rsspages_sub(mm, HPAGE_SIZE / PAGE_SIZE);
 	entry = mk_hugepte(page, write_access);
 	for (i = 0; i < HUGEPTE_BATCH_SIZE; i++)
 		set_hugepte(ptep+i, entry);
@@ -287,7 +288,8 @@ int copy_hugetlb_page_range(struct mm_st
 			/* This is the first hugepte in a batch */
 			ptepage = hugepte_page(entry);
 			get_page(ptepage);
-			dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+			// dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+			vx_rsspages_add(dst, HPAGE_SIZE / PAGE_SIZE);
 		}
 		set_hugepte(dst_pte, entry);
 
@@ -410,7 +412,8 @@ void unmap_hugepage_range(struct vm_area
 	}
 	put_cpu();
 
-	mm->rss -= (end - start) >> PAGE_SHIFT;
+	// mm->rss -= (end - start) >> PAGE_SHIFT;
+	vx_rsspages_sub(mm, (end - start) >> PAGE_SHIFT);
 }
 
 int hugetlb_prefault(struct address_space *mapping, struct vm_area_struct *vma)
diff -NurpP --minimal linux-2.6.8.1/arch/s390/Kconfig linux-2.6.8.1-vs1.9.2/arch/s390/Kconfig
--- linux-2.6.8.1/arch/s390/Kconfig	2004-08-14 12:55:19.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/s390/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -443,6 +443,8 @@ config DEBUG_SPINLOCK_SLEEP
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/s390/kernel/compat_exec.c linux-2.6.8.1-vs1.9.2/arch/s390/kernel/compat_exec.c
--- linux-2.6.8.1/arch/s390/kernel/compat_exec.c	2004-08-14 12:56:01.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/s390/kernel/compat_exec.c	2004-08-25 18:49:34.000000000 +0200
@@ -36,7 +36,7 @@
 
 int setup_arg_pages32(struct linux_binprm *bprm, int executable_stack)
 {
-	unsigned long stack_base;
+	unsigned long stack_base, grow;
 	struct vm_area_struct *mpnt;
 	struct mm_struct *mm = current->mm;
 	int i;
@@ -53,7 +53,10 @@ int setup_arg_pages32(struct linux_binpr
 	if (!mpnt) 
 		return -ENOMEM; 
 	
-	if (security_vm_enough_memory((STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))>>PAGE_SHIFT)) {
+	grow = (STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))
+		>> PAGE_SHIFT;
+	if (security_vm_enough_memory(grow) ||
+		!vx_vmpages_avail(mm, grow)) {
 		kmem_cache_free(vm_area_cachep, mpnt);
 		return -ENOMEM;
 	}
@@ -69,7 +72,9 @@ int setup_arg_pages32(struct linux_binpr
 		mpnt->vm_page_prot = PAGE_COPY;
 		mpnt->vm_flags = VM_STACK_FLAGS;
 		insert_vm_struct(mm, mpnt);
-		mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		// mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		vx_vmpages_sub(mm, mm->total_vm -
+			((mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT));
 	} 
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
diff -NurpP --minimal linux-2.6.8.1/arch/s390/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/s390/kernel/ptrace.c
--- linux-2.6.8.1/arch/s390/kernel/ptrace.c	2004-08-14 12:56:14.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/s390/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -695,9 +695,11 @@ sys_ptrace(long request, long pid, long 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = do_ptrace(child, request, addr, data);
-
+out_tsk:
 	put_task_struct(child);
 out:
 	unlock_kernel();
diff -NurpP --minimal linux-2.6.8.1/arch/s390/kernel/syscalls.S linux-2.6.8.1-vs1.9.2/arch/s390/kernel/syscalls.S
--- linux-2.6.8.1/arch/s390/kernel/syscalls.S	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/s390/kernel/syscalls.S	2004-08-25 18:49:25.000000000 +0200
@@ -271,7 +271,7 @@ SYSCALL(sys_clock_settime,sys_clock_sett
 SYSCALL(sys_clock_gettime,sys_clock_gettime,sys32_clock_gettime_wrapper)	/* 260 */
 SYSCALL(sys_clock_getres,sys_clock_getres,sys32_clock_getres_wrapper)
 SYSCALL(sys_clock_nanosleep,sys_clock_nanosleep,sys32_clock_nanosleep_wrapper)
-NI_SYSCALL							/* reserved for vserver */
+SYSCALL(sys_vserver,sys_vserver,sys_vserver)
 SYSCALL(s390_fadvise64_64,sys_ni_syscall,sys32_fadvise64_64_wrapper)
 SYSCALL(sys_statfs64,sys_statfs64,compat_sys_statfs64_wrapper)
 SYSCALL(sys_fstatfs64,sys_fstatfs64,compat_sys_fstatfs64_wrapper)
diff -NurpP --minimal linux-2.6.8.1/arch/sh/Kconfig linux-2.6.8.1-vs1.9.2/arch/sh/Kconfig
--- linux-2.6.8.1/arch/sh/Kconfig	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sh/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -894,6 +894,8 @@ config FRAME_POINTER
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/sh/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/sh/kernel/ptrace.c
--- linux-2.6.8.1/arch/sh/kernel/ptrace.c	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sh/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -108,6 +108,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/sh/mm/hugetlbpage.c linux-2.6.8.1-vs1.9.2/arch/sh/mm/hugetlbpage.c
--- linux-2.6.8.1/arch/sh/mm/hugetlbpage.c	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sh/mm/hugetlbpage.c	2004-08-25 18:49:34.000000000 +0200
@@ -62,7 +62,8 @@ static void set_huge_pte(struct mm_struc
 	unsigned long i;
 	pte_t entry;
 
-	mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	// mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	vx_rsspages_add(mm, HPAGE_SIZE / PAGE_SIZE);
 
 	if (write_access)
 		entry = pte_mkwrite(pte_mkdirty(mk_pte(page,
@@ -115,7 +116,8 @@ int copy_hugetlb_page_range(struct mm_st
 			pte_val(entry) += PAGE_SIZE;
 			dst_pte++;
 		}
-		dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		// dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		vx_rsspages_add(dst, HPAGE_SIZE / PAGE_SIZE);
 		addr += HPAGE_SIZE;
 	}
 	return 0;
@@ -206,7 +208,8 @@ void unmap_hugepage_range(struct vm_area
 			pte++;
 		}
 	}
-	mm->rss -= (end - start) >> PAGE_SHIFT;
+	// mm->rss -= (end - start) >> PAGE_SHIFT;
+	vx_rsspages_sub(mm, (end - start) >> PAGE_SHIFT);
 	flush_tlb_range(vma, start, end);
 }
 
diff -NurpP --minimal linux-2.6.8.1/arch/sparc/Kconfig linux-2.6.8.1-vs1.9.2/arch/sparc/Kconfig
--- linux-2.6.8.1/arch/sparc/Kconfig	2004-08-14 12:54:46.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -452,6 +452,8 @@ config DEBUG_BUGVERBOSE
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/sparc/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/ptrace.c
--- linux-2.6.8.1/arch/sparc/kernel/ptrace.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -321,6 +321,10 @@ asmlinkage void do_ptrace(struct pt_regs
 		pt_error_return(regs, ESRCH);
 		goto out;
 	}
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT)) {
+		pt_error_return(regs, ESRCH);
+		goto out_tsk;
+	}
 
 	if ((current->personality == PER_SUNOS && request == PTRACE_SUNATTACH)
 	    || (current->personality != PER_SUNOS && request == PTRACE_ATTACH)) {
diff -NurpP --minimal linux-2.6.8.1/arch/sparc/kernel/sys_sparc.c linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/sys_sparc.c
--- linux-2.6.8.1/arch/sparc/kernel/sys_sparc.c	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/sys_sparc.c	2004-08-25 18:49:25.000000000 +0200
@@ -21,6 +21,7 @@
 #include <linux/utsname.h>
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -471,13 +472,13 @@ asmlinkage int sys_getdomainname(char __
  	
  	down_read(&uts_sem);
  	
-	nlen = strlen(system_utsname.domainname) + 1;
+	nlen = strlen(vx_new_uts(domainname)) + 1;
 
 	if (nlen < len)
 		len = nlen;
 	if (len > __NEW_UTS_LEN)
 		goto done;
-	if (copy_to_user(name, system_utsname.domainname, len))
+	if (copy_to_user(name, vx_new_uts(domainname), len))
 		goto done;
 	err = 0;
 done:
diff -NurpP --minimal linux-2.6.8.1/arch/sparc/kernel/systbls.S linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/systbls.S
--- linux-2.6.8.1/arch/sparc/kernel/systbls.S	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc/kernel/systbls.S	2004-08-25 18:49:25.000000000 +0200
@@ -72,7 +72,7 @@ sys_call_table:
 /*250*/	.long sparc_mremap, sys_sysctl, sys_getsid, sys_fdatasync, sys_nfsservctl
 /*255*/	.long sys_nis_syscall, sys_clock_settime, sys_clock_gettime, sys_clock_getres, sys_clock_nanosleep
 /*260*/	.long sys_sched_getaffinity, sys_sched_setaffinity, sys_timer_settime, sys_timer_gettime, sys_timer_getoverrun
-/*265*/	.long sys_timer_delete, sys_timer_create, sys_nis_syscall, sys_io_setup, sys_io_destroy
+/*265*/	.long sys_timer_delete, sys_timer_create, sys_vserver, sys_io_setup, sys_io_destroy
 /*270*/	.long sys_io_submit, sys_io_cancel, sys_io_getevents, sys_mq_open, sys_mq_unlink
 /*275*/	.long sys_mq_timedsend, sys_mq_timedreceive, sys_mq_notify, sys_mq_getsetattr, sys_ni_syscall
 /*280*/	.long sys_ni_syscall, sys_ni_syscall, sys_ni_syscall
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/Kconfig linux-2.6.8.1-vs1.9.2/arch/sparc64/Kconfig
--- linux-2.6.8.1/arch/sparc64/Kconfig	2004-08-14 12:56:01.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -708,6 +708,8 @@ config FRAME_POINTER
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/kernel/binfmt_aout32.c linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/binfmt_aout32.c
--- linux-2.6.8.1/arch/sparc64/kernel/binfmt_aout32.c	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/binfmt_aout32.c	2004-08-25 18:49:34.000000000 +0200
@@ -27,6 +27,7 @@
 #include <linux/binfmts.h>
 #include <linux/personality.h>
 #include <linux/init.h>
+#include <linux/vs_memory.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
@@ -239,7 +240,8 @@ static int load_aout32_binary(struct lin
 	current->mm->brk = ex.a_bss +
 		(current->mm->start_brk = N_BSSADDR(ex));
 
-	current->mm->rss = 0;
+	// current->mm->rss = 0;
+	vx_rsspages_sub(current->mm, current->mm->rss);
 	current->mm->mmap = NULL;
 	compute_creds(bprm);
  	current->flags &= ~PF_FORKNOEXEC;
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/ptrace.c
--- linux-2.6.8.1/arch/sparc64/kernel/ptrace.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -172,6 +172,10 @@ asmlinkage void do_ptrace(struct pt_regs
 		pt_error_return(regs, ESRCH);
 		goto out;
 	}
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT)) {
+		pt_error_return(regs, ESRCH);
+		goto out_tsk;
+	}
 
 	if ((current->personality == PER_SUNOS && request == PTRACE_SUNATTACH)
 	    || (current->personality != PER_SUNOS && request == PTRACE_ATTACH)) {
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/kernel/sys_sparc.c linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/sys_sparc.c
--- linux-2.6.8.1/arch/sparc64/kernel/sys_sparc.c	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/sys_sparc.c	2004-08-25 18:49:25.000000000 +0200
@@ -25,6 +25,7 @@
 #include <linux/syscalls.h>
 #include <linux/ipc.h>
 #include <linux/personality.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -465,13 +466,13 @@ asmlinkage long sys_getdomainname(char _
 
  	down_read(&uts_sem);
  	
-	nlen = strlen(system_utsname.domainname) + 1;
+	nlen = strlen(vx_new_uts(domainname)) + 1;
 
         if (nlen < len)
                 len = nlen;
 	if (len > __NEW_UTS_LEN)
 		goto done;
-	if (copy_to_user(name, system_utsname.domainname, len))
+	if (copy_to_user(name, vx_new_uts(domainname), len))
 		goto done;
 	err = 0;
 done:
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/kernel/systbls.S linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/systbls.S
--- linux-2.6.8.1/arch/sparc64/kernel/systbls.S	2004-08-14 12:55:20.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/kernel/systbls.S	2004-08-25 18:49:25.000000000 +0200
@@ -73,7 +73,7 @@ sys_call_table32:
 /*250*/	.word sys32_mremap, sys32_sysctl, sys32_getsid, sys_fdatasync, sys32_nfsservctl
 	.word sys_ni_syscall, sys32_clock_settime, compat_clock_gettime, compat_clock_getres, sys32_clock_nanosleep
 /*260*/	.word compat_sys_sched_getaffinity, compat_sys_sched_setaffinity, sys32_timer_settime, compat_timer_gettime, sys_timer_getoverrun
-	.word sys_timer_delete, sys32_timer_create, sys_ni_syscall, compat_sys_io_setup, sys_io_destroy
+	.word sys_timer_delete, sys32_timer_create, sys_vserver, compat_sys_io_setup, sys_io_destroy
 /*270*/	.word sys32_io_submit, sys_io_cancel, compat_sys_io_getevents, sys32_mq_open, sys_mq_unlink
 	.word sys_mq_timedsend, sys_mq_timedreceive, compat_sys_mq_notify, compat_sys_mq_getsetattr, sys_ni_syscall
 /*280*/	.word sys_ni_syscall, sys_ni_syscall, sys_ni_syscall
@@ -139,7 +139,7 @@ sys_call_table:
 /*250*/	.word sys64_mremap, sys_sysctl, sys_getsid, sys_fdatasync, sys_nfsservctl
 	.word sys_ni_syscall, sys_clock_settime, sys_clock_gettime, sys_clock_getres, sys_clock_nanosleep
 /*260*/	.word sys_sched_getaffinity, sys_sched_setaffinity, sys_timer_settime, sys_timer_gettime, sys_timer_getoverrun
-	.word sys_timer_delete, sys_timer_create, sys_ni_syscall, sys_io_setup, sys_io_destroy
+	.word sys_timer_delete, sys_timer_create, sys_vserver, sys_io_setup, sys_io_destroy
 /*270*/	.word sys_io_submit, sys_io_cancel, sys_io_getevents, sys_mq_open, sys_mq_unlink
 	.word sys_mq_timedsend, sys_mq_timedreceive, sys_mq_notify, sys_mq_getsetattr, sys_ni_syscall
 /*280*/	.word sys_ni_syscall, sys_ni_syscall, sys_ni_syscall
diff -NurpP --minimal linux-2.6.8.1/arch/sparc64/mm/hugetlbpage.c linux-2.6.8.1-vs1.9.2/arch/sparc64/mm/hugetlbpage.c
--- linux-2.6.8.1/arch/sparc64/mm/hugetlbpage.c	2004-08-14 12:55:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/sparc64/mm/hugetlbpage.c	2004-08-25 18:49:34.000000000 +0200
@@ -59,7 +59,8 @@ static void set_huge_pte(struct mm_struc
 	unsigned long i;
 	pte_t entry;
 
-	mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	// mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	vx_rsspages_add(mm, HPAGE_SIZE / PAGE_SIZE);
 
 	if (write_access)
 		entry = pte_mkwrite(pte_mkdirty(mk_pte(page,
@@ -112,7 +113,8 @@ int copy_hugetlb_page_range(struct mm_st
 			pte_val(entry) += PAGE_SIZE;
 			dst_pte++;
 		}
-		dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		// dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		vx_rsspages_add(dst, HPAGE_SIZE / PAGE_SIZE);
 		addr += HPAGE_SIZE;
 	}
 	return 0;
@@ -203,7 +205,8 @@ void unmap_hugepage_range(struct vm_area
 			pte++;
 		}
 	}
-	mm->rss -= (end - start) >> PAGE_SHIFT;
+	// mm->rss -= (end - start) >> PAGE_SHIFT;
+	vx_rsspages_sub(mm, (end - start) >> PAGE_SHIFT);
 	flush_tlb_range(vma, start, end);
 }
 
diff -NurpP --minimal linux-2.6.8.1/arch/um/Kconfig linux-2.6.8.1-vs1.9.2/arch/um/Kconfig
--- linux-2.6.8.1/arch/um/Kconfig	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/um/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -188,6 +188,8 @@ source "net/Kconfig"
 
 source "fs/Kconfig"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/um/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/um/kernel/ptrace.c
--- linux-2.6.8.1/arch/um/kernel/ptrace.c	2004-08-14 12:56:25.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/um/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -58,6 +58,8 @@ int sys_ptrace(long request, long pid, l
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/um/kernel/sys_call_table.c linux-2.6.8.1-vs1.9.2/arch/um/kernel/sys_call_table.c
--- linux-2.6.8.1/arch/um/kernel/sys_call_table.c	2004-08-14 12:56:00.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/um/kernel/sys_call_table.c	2004-08-25 18:49:25.000000000 +0200
@@ -237,6 +237,8 @@ extern syscall_handler_t sys_epoll_wait;
 extern syscall_handler_t sys_remap_file_pages;
 extern syscall_handler_t sys_set_tid_address;
 
+extern syscall_handler_t sys_vserver;
+
 #ifdef CONFIG_NFSD
 #define NFSSERVCTL sys_nfsservctl
 #else
@@ -489,6 +491,7 @@ syscall_handler_t *sys_call_table[] = {
 	[ __NR_epoll_wait ] = sys_epoll_wait,
         [ __NR_remap_file_pages ] = sys_remap_file_pages,
         [ __NR_set_tid_address ] = sys_set_tid_address,
+        [ __NR_vserver ] = sys_vserver,
 
 	ARCH_SYSCALLS
 	[ LAST_SYSCALL + 1 ... NR_syscalls ] = 
diff -NurpP --minimal linux-2.6.8.1/arch/um/kernel/syscall_kern.c linux-2.6.8.1-vs1.9.2/arch/um/kernel/syscall_kern.c
--- linux-2.6.8.1/arch/um/kernel/syscall_kern.c	2004-08-14 12:55:48.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/um/kernel/syscall_kern.c	2004-08-25 18:49:25.000000000 +0200
@@ -15,6 +15,8 @@
 #include "linux/unistd.h"
 #include "linux/slab.h"
 #include "linux/utime.h"
+#include <linux/vs_cvirt.h>
+
 #include "asm/mman.h"
 #include "asm/uaccess.h"
 #include "asm/ipc.h"
@@ -264,7 +266,7 @@ int sys_uname(struct old_utsname * name)
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
@@ -272,6 +274,7 @@ int sys_uname(struct old_utsname * name)
 int sys_olduname(struct oldold_utsname * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -280,19 +283,20 @@ int sys_olduname(struct oldold_utsname *
   
   	down_read(&uts_sem);
 	
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,
 			       __OLD_UTS_LEN);
 	error |= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename,&system_utsname.nodename,
+	error |= __copy_to_user(&name->nodename,ptr->nodename,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release,&system_utsname.release,
+	error |= __copy_to_user(&name->release,ptr->release,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->release+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version,&system_utsname.version,
+	error |= __copy_to_user(&name->version,ptr->version,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->version+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine,&system_utsname.machine,
+	error |= __copy_to_user(&name->machine,ptr->machine,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->machine+__OLD_UTS_LEN);
 	
diff -NurpP --minimal linux-2.6.8.1/arch/v850/Kconfig linux-2.6.8.1-vs1.9.2/arch/v850/Kconfig
--- linux-2.6.8.1/arch/v850/Kconfig	2004-08-14 12:55:31.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/v850/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -334,6 +334,8 @@ config NO_KERNEL_MSG
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/v850/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/v850/kernel/ptrace.c
--- linux-2.6.8.1/arch/v850/kernel/ptrace.c	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/v850/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -138,6 +138,8 @@ int sys_ptrace(long request, long pid, l
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	rval = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/Kconfig linux-2.6.8.1-vs1.9.2/arch/x86_64/Kconfig
--- linux-2.6.8.1/arch/x86_64/Kconfig	2004-08-14 12:55:59.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -499,6 +499,8 @@ config IOMMU_LEAK
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/ia32/ia32_aout.c linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32_aout.c
--- linux-2.6.8.1/arch/x86_64/ia32/ia32_aout.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32_aout.c	2004-08-25 18:49:34.000000000 +0200
@@ -25,6 +25,7 @@
 #include <linux/binfmts.h>
 #include <linux/personality.h>
 #include <linux/init.h>
+#include <linux/vs_memory.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
@@ -309,7 +310,8 @@ static int load_aout_binary(struct linux
 		(current->mm->start_brk = N_BSSADDR(ex));
 	current->mm->free_area_cache = TASK_UNMAPPED_BASE;
 
-	current->mm->rss = 0;
+	// current->mm->rss = 0;
+	vx_rsspages_sub(current->mm, current->mm->rss);
 	current->mm->mmap = NULL;
 	compute_creds(bprm);
  	current->flags &= ~PF_FORKNOEXEC;
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/ia32/ia32_binfmt.c linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32_binfmt.c
--- linux-2.6.8.1/arch/x86_64/ia32/ia32_binfmt.c	2004-08-14 12:54:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32_binfmt.c	2004-08-25 18:49:34.000000000 +0200
@@ -327,7 +327,7 @@ static void elf32_init(struct pt_regs *r
 
 int setup_arg_pages(struct linux_binprm *bprm, int executable_stack)
 {
-	unsigned long stack_base;
+	unsigned long stack_base, grow;
 	struct vm_area_struct *mpnt;
 	struct mm_struct *mm = current->mm;
 	int i;
@@ -344,7 +344,10 @@ int setup_arg_pages(struct linux_binprm 
 	if (!mpnt) 
 		return -ENOMEM; 
 	
-	if (security_vm_enough_memory((IA32_STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))>>PAGE_SHIFT)) {
+	grow = (IA32_STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))
+		>> PAGE_SHIFT;
+	if (security_vm_enough_memory(grow) ||
+		!vx_vmpages_avail(mm, grow)) {
 		kmem_cache_free(vm_area_cachep, mpnt);
 		return -ENOMEM;
 	}
@@ -365,7 +368,9 @@ int setup_arg_pages(struct linux_binprm 
  		mpnt->vm_page_prot = (mpnt->vm_flags & VM_EXEC) ? 
  			PAGE_COPY_EXEC : PAGE_COPY;
 		insert_vm_struct(mm, mpnt);
-		mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		// mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		vx_vmpages_sub(mm, mm->total_vm -
+			((mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT));
 	} 
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/ia32/ia32entry.S linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32entry.S
--- linux-2.6.8.1/arch/x86_64/ia32/ia32entry.S	2004-08-14 12:55:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/ia32entry.S	2004-08-25 18:49:25.000000000 +0200
@@ -578,7 +578,7 @@ ia32_sys_call_table:
 	.quad sys_tgkill		/* 270 */
 	.quad compat_sys_utimes
 	.quad sys32_fadvise64_64
-	.quad quiet_ni_syscall	/* sys_vserver */
+	.quad sys_vserver
 	.quad sys_mbind
 	.quad compat_get_mempolicy	/* 275 */
 	.quad sys_set_mempolicy
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/ia32/sys_ia32.c linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/sys_ia32.c
--- linux-2.6.8.1/arch/x86_64/ia32/sys_ia32.c	2004-08-14 12:55:20.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/ia32/sys_ia32.c	2004-08-25 18:49:25.000000000 +0200
@@ -61,6 +61,7 @@
 #include <linux/ptrace.h>
 #include <linux/highuid.h>
 #include <linux/vmalloc.h>
+#include <linux/vs_cvirt.h>
 #include <asm/mman.h>
 #include <asm/types.h>
 #include <asm/uaccess.h>
@@ -1059,6 +1060,7 @@ asmlinkage long sys32_mmap2(unsigned lon
 asmlinkage long sys32_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -1067,13 +1069,14 @@ asmlinkage long sys32_olduname(struct ol
   
   	down_read(&uts_sem);
 	
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	 __put_user(0,name->sysname+__OLD_UTS_LEN);
-	 __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	 __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	 __put_user(0,name->nodename+__OLD_UTS_LEN);
-	 __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	 __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	 __put_user(0,name->release+__OLD_UTS_LEN);
-	 __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	 __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	 __put_user(0,name->version+__OLD_UTS_LEN);
 	 { 
 		 char *arch = "x86_64";
@@ -1096,7 +1099,7 @@ long sys32_uname(struct old_utsname __us
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	if (personality(current->personality) == PER_LINUX32) 
 		err |= copy_to_user(&name->machine, "i686", 5);
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/x86_64/kernel/ptrace.c
--- linux-2.6.8.1/arch/x86_64/kernel/ptrace.c	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -208,6 +208,8 @@ asmlinkage long sys_ptrace(long request,
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/x86_64/kernel/sys_x86_64.c linux-2.6.8.1-vs1.9.2/arch/x86_64/kernel/sys_x86_64.c
--- linux-2.6.8.1/arch/x86_64/kernel/sys_x86_64.c	2004-08-14 12:55:35.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/x86_64/kernel/sys_x86_64.c	2004-08-25 18:49:25.000000000 +0200
@@ -16,6 +16,7 @@
 #include <linux/file.h>
 #include <linux/utsname.h>
 #include <linux/personality.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -146,7 +147,7 @@ asmlinkage long sys_uname(struct new_uts
 {
 	int err;
 	down_read(&uts_sem);
-	err = copy_to_user(name, &system_utsname, sizeof (*name));
+	err = copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	if (personality(current->personality) == PER_LINUX32) 
 		err |= copy_to_user(&name->machine, "i686", 5); 		
diff -NurpP --minimal linux-2.6.8.1/fs/attr.c linux-2.6.8.1-vs1.9.2/fs/attr.c
--- linux-2.6.8.1/fs/attr.c	2004-08-14 12:54:50.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/fs/attr.c	2004-08-25 18:49:35.000000000 +0200
@@ -14,6 +14,9 @@
 #include <linux/fcntl.h>
 #include <linux/quotaops.h>
 #include <linux/security.h>
+#include <linux/vs_base.h>
+#include <linux/proc_fs.h>
+#include <linux/devpts_fs.h>
 
 /* Taken over from the old code... */
 
@@ -55,6 +58,31 @@ int inode_change_ok(struct inode *inode,
 		if (current->fsuid != inode->i_uid && !capable(CAP_FOWNER))
 			goto error;
 	}
+
+	/* Check for evil vserver activity */
+	if (vx_check(0, VX_ADMIN))
+		goto fine;
+
+	if (IS_BARRIER(inode)) {
+		printk(KERN_WARNING
+			"VSW: xid=%d messing with the barrier.\n",
+			vx_current_xid());
+		goto error;
+	}
+	switch (inode->i_sb->s_magic) {
+		case PROC_SUPER_MAGIC:
+			printk(KERN_WARNING
+				"VSW: xid=%d messing with the procfs.\n",
+				vx_current_xid());
+			goto error;
+		case DEVPTS_SUPER_MAGIC:
+			if (vx_check(inode->i_xid, VX_IDENT))
+				goto fine;
+			printk(KERN_WARNING
+				"VSW: xid=%d messing with the devpts.\n",
+				vx_current_xid());
+			goto error;	
+	}
 fine:
 	retval = 0;
 error:
@@ -63,6 +91,24 @@ error:
 
 EXPORT_SYMBOL(inode_change_ok);
 
+int inode_setattr_flags(struct inode *inode, unsigned int flags)
+{
+	unsigned int oldflags, newflags;
+
+	oldflags = inode->i_flags;
+	newflags = oldflags & ~(S_IMMUTABLE | S_IUNLINK | S_BARRIER);
+	if (flags & ATTR_FLAG_IMMUTABLE)
+		newflags |= S_IMMUTABLE;
+	if (flags & ATTR_FLAG_IUNLINK)
+		newflags |= S_IUNLINK;
+	if (flags & ATTR_FLAG_BARRIER)
+		newflags |= S_BARRIER;
+
+	if (oldflags ^ newflags)
+		inode->i_flags = newflags;
+	return 0;
+}
+
 int inode_setattr(struct inode * inode, struct iattr * attr)
 {
 	unsigned int ia_valid = attr->ia_valid;
@@ -86,6 +132,8 @@ int inode_setattr(struct inode * inode, 
 		inode->i_uid = attr->ia_uid;
 	if (ia_valid & ATTR_GID)
 		inode->i_gid = attr->ia_gid;
+	if (ia_valid & ATTR_XID)
+		inode->i_xid = attr->ia_xid;
 	if (ia_valid & ATTR_ATIME)
 		inode->i_atime = attr->ia_atime;
 	if (ia_valid & ATTR_MTIME)
@@ -99,6 +147,8 @@ int inode_setattr(struct inode * inode, 
 			mode &= ~S_ISGID;
 		inode->i_mode = mode;
 	}
+	if (ia_valid & ATTR_ATTR_FLAG)
+		inode_setattr_flags(inode, attr->ia_attr_flags);
 	mark_inode_dirty(inode);
 out:
 	return error;
@@ -114,6 +164,8 @@ int setattr_mask(unsigned int ia_valid)
 		dn_mask |= DN_ATTRIB;
 	if (ia_valid & ATTR_GID)
 		dn_mask |= DN_ATTRIB;
+	if (ia_valid & ATTR_XID)
+		dn_mask |= DN_ATTRIB;
 	if (ia_valid & ATTR_SIZE)
 		dn_mask |= DN_MODIFY;
 	/* both times implies a utime(s) call */
@@ -177,7 +229,8 @@ int notify_change(struct dentry * dentry
 			error = security_inode_setattr(dentry, attr);
 		if (!error) {
 			if ((ia_valid & ATTR_UID && attr->ia_uid != inode->i_uid) ||
-			    (ia_valid & ATTR_GID && attr->ia_gid != inode->i_gid))
+			    (ia_valid & ATTR_GID && attr->ia_gid != inode->i_gid) ||
+			    (ia_valid & ATTR_XID && attr->ia_xid != inode->i_xid))
 				error = DQUOT_TRANSFER(inode, attr) ? -EDQUOT : 0;
 			if (!error)
 				error = inode_setattr(inode, attr);
